/* 
Bollinger Bands     .     

   :
iCustom( string symbol, int timeframe, "_BandsFBA_NR", int period, double deviation, int bands_shift, int applied_price, 
double FrontPeriod, double BackPeriod, int mode, double Sens, int shift);

iCustom(NULL,0,"_BandsFBA_NR",BandsPeriod,Deviation,BandsShift,PriceField,FrontPeriod,BackPeriod,Sens, 1,i); //  .
iCustom(NULL,0,"_BandsFBA_NR",BandsPeriod,Deviation,BandsShift,PriceField,FrontPeriod,BackPeriod,Sens, 2,i); //  .
iCustom(NULL,0,"_BandsFBA_NR",BandsPeriod,Deviation,BandsShift,PriceField,FrontPeriod,BackPeriod,Sens, 4,i); //   .
iCustom(NULL,0,"_BandsFBA_NR",BandsPeriod,Deviation,BandsShift,PriceField,FrontPeriod,BackPeriod,Sens, 5,i); //   .
*/
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 MediumSeaGreen // MA
#property indicator_color2 MediumSeaGreen //  
#property indicator_color3 MediumSeaGreen //  
#property indicator_color4 Red // MA 
#property indicator_color5 Red //  
#property indicator_color6 Red //  

//  
   // Bollinger Bands
extern int BandsPeriod=20; //  .
extern double Deviation=2; // 
extern int BandsShift=0; //  
extern int PriceField=0; //   (. )
   // 
extern double FrontPeriod=1; //   ; .. <1
extern double BackPeriod=55; //   ; .. <1
extern double Sens=0; //    .

 int History=0; // - ; 0 -  

// .
double   SMA[], // SMA
         TopB[], //  
         BotB[], //  
         SMAS[], //  
         TopS[], //  
         BotS[]; //  

//  
bool first=1; //   
double per0,per1; // - EMA
int FBA=0; // 1 -  , -1 -  , 0 -  MA -  !
double sens; //    

int init()
  {
   first=1;
   sens=Sens*Point; //    

   int fdg,bdg,ddg; //   
   if(FrontPeriod<1) fdg=2; if(BackPeriod<1) bdg=2; if(Deviation-MathRound(Deviation)!=0) ddg=2;
   string _fr=DoubleToStr(FrontPeriod,fdg);
   string _bk=DoubleToStr(BackPeriod,bdg);
   string _dv=DoubleToStr(Deviation,ddg);

   if(FrontPeriod>1) FrontPeriod=2.0/(1+FrontPeriod); // .  EMA
   if(BackPeriod>1) BackPeriod=2.0/(1+BackPeriod); // .  EMA
   while(true) {
      if(FrontPeriod==BackPeriod) {
         per0=FrontPeriod; per1=1; string _sg=_fr; break;
        }
      if(FrontPeriod>BackPeriod) {
         FBA=-1; per0=FrontPeriod; per1=BackPeriod; _sg=_fr;
        }
      else {
         FBA= 1; per0=BackPeriod; per1=FrontPeriod; _sg=_bk;
        }
      break;
     }

   // .    
   // SMA -  Bollinger Bands
   SetIndexBuffer(0,SMA);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"SMA("+BandsPeriod+")");
   //  
   SetIndexBuffer(1,TopB);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"TopB(+"+_dv+")");
   //  
   SetIndexBuffer(2,BotB);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"BotB(-"+_dv+")");
   // SMA -  Bollinger Bands 
   SetIndexBuffer(3,SMAS);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"SMAS("+_sg+")");
   //   
   SetIndexBuffer(4,TopS);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexLabel(4,"TopS("+_fr+","+_bk+")");
   //   
   SetIndexBuffer(5,BotS);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexLabel(5,"BotS("+_fr+","+_bk+")");

   return(0);
  }


int reinit() // -  
  {
   ArrayInitialize(SMA,0.0);
   ArrayInitialize(TopB,0.0);
   ArrayInitialize(BotB,0.0);
   ArrayInitialize(TopS,0.0);
   ArrayInitialize(BotS,0.0);

   return(0);
  }

int start()
  {
   int ic=IndicatorCounted();
   //if(!first && Bars-ic-1>1) ic=reinit(); 
   //int limit=Bars-ic-1; // - 
   //if(History!=0 && limit>History) limit=History-1; // -   
   
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit--;

   for(int i=limit; i>=0; i--) { //     
      bool reset=i==limit && ic==0; //      
         if(reset) {
         static double MA0prev=0,MA1prev=0,sma0prev=0; 
         static int BarsPrev=0;
      }
      int sh=i+BandsShift; // 

      //  Bollinger Bands
      double sma=iMA(NULL,0,BandsPeriod,0,0,PriceField, sh);
      SMA[i]=sma;

      //  
      double st=iStdDev(NULL,0,BandsPeriod,0,0,PriceField, sh); 
      st=MathMax(st,sens); //   
      double std=Deviation*st;
      
      //  Bollinger Bands
      TopB[i]=sma+std; //  
      BotB[i]=sma-std; //  

      //  
      double MA0=EMA_FBA(st,MA0prev,per0,0,i);
      double sma0=EMA_FBA(sma,sma0prev,per0,0,i);
      SMAS[i]=sma0;
      
      //  ()
      double MA1=EMA_FBA(MA0,MA1prev,per1,FBA,i);
      
      //  
      std=Deviation*MA1;
      //  
      TopS[i]=sma0+std; //  
      BotS[i]=sma0-std; //  
      
      // 
      if(first || BarsPrev!=Bars) {BarsPrev=Bars; MA0prev=MA0; MA1prev=MA1; sma0prev=sma0;}
     }   

   first=0; //    
   return(0);
  }

// EMA        
double EMA_FBA(double C, double MA1, double period, int FBA, int i) {
   if(period==1) return(C);
   // . EMA 
   if(period>1) period=2.0/(1+period); 
   // EMA
   double ma=period*C+(1-period)*MA1; 
   //    
   switch(FBA) {
      case  0: //  MA
         if(FBA==0) return(ma); 
      case  1: //  
         if(C>MA1) return(ma); else return(C); 
      case -1: //  
         if(C<MA1) return(ma); else return(C); 
     }
  }